<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004-2005 Alessandro De Zorzi and Mirko Grava
 *  
 * Phamm is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Phamm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* @package application
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/

// Start the Session
session_start();

// Set the HTTP Charset Parameter as UTF-8
header("Content-type: text/html; charset=utf-8");

// Set the Main Variables with Method GET or POST or Both
// This variables can be used by all plugins

// *** action ***
$action		= $_POST["action"];
if (!$_POST["action"])
    $action = $_GET["action"];

// *** domain ***
if (isset($_SESSION["domain"]))
	$domain		= $_SESSION["domain"];
if (!$_SESSION["domain"])
    $domain = $_GET["domain"];
if (!$_SESSION["domain"] && !$_GET["domain"])
    $domain = $_POST["domain"];

// *** initial ***
$initial	= $_GET["initial"];
if (!$_GET["initial"])
    $initial = $_POST["initial"];

// *+*+* CONFIG AND FUNCTIONS *+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+ //

// Require the main Phamm config file if exists
if (file_exists("config.inc.php"))
{
    require ('config.inc.php');
}

// If the main Phamm config file don't exists
// redirect to setup.php to create it
else
{
	header("location:setup.php");
	exit();
}

// Require the plugins config file (one for each plugin) if exist
if (USE_PLUGINS == 1)
{
	for ($i=0; $i < count($plugins); $i++)
	{
		if (file_exists("plugins/$plugins[$i]/config.inc.php"))
		{
			require ("./plugins/$plugins[$i]/config.inc.php");
		}
	}
}

// If don't use plugins, require only the default plugin config file 
else
{
		require ("./plugins/".DEFAULT_PLUGIN."/config.inc.php");
}

// Force HTTPS if required
if (FORCE_SSL == 1 && (!isset($_SERVER['HTTPS']) || $_SERVER['HTTPS'] != "on"))
{
	$url=$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
	header ("Location: https://$url");
}

// Set the language defined in config file
if (!$_SESSION["language"] && !$_GET["language"])
{
	$_SESSION["language"] = $language;
}

// Supported Languages defined in config.inc.php
// *** TODO check
// if ($_GET["language"] && in_array($_GET["language"],$supported_languages))
// Change language is permit with GET method
if ($_GET["language"])
{
	// Change the language in current SESSION
	// could be different by the default language
	$_SESSION["language"] = $_GET["language"];
}

// Set English as default if language unsetting
elseif (!$_SESSION["language"] && !$_GET["language"])
{
	$_SESSION["language"] = 'en_GB';
}

// Set the current language
$language = $_SESSION["language"];

// Require locale file if exists or the English
if (file_exists("./lang/$language.php"))
{
    require ("./lang/$language.php");
}

// ...This is safe
else
{
    require ("./lang/en_EN.php");
}

// Change the current plugin name
if ($_GET["pn"])
	$_SESSION["pn"] = $_GET["pn"];

// Set the default plugin if unchanged
elseif (!isset($_SESSION["pn"]))
	$_SESSION["pn"] = DEFAULT_PLUGIN;

// ** Require the library file with all functions
// ** require ('phamm_functions.inc.php');
// ** To develop include single file funtion
// ** this is not a safe way to include file :-P
$mydir = opendir("functions");
while($fn = readdir($mydir))
{
    if (substr($fn,-3) == 'php')
        require ("functions/$fn");
}
closedir($mydir);

// Set the PHP ERROL_LEVEL for DEBUG
php_error_level ();

// *+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+* //

// Open the LDAP connection
$connect = @ldap_connect("$LDAP_SERVER",LDAP_PORT)
           or die ("$lang[error_connection]");

// Read the header template
include ('./templates/header.html.php');

// *=*=*= LOGIN SECTION *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*= //

// Check if login system is not disable
if (NOLOGIN != '1')
{
    // Try login if the user is not already logged
    if (!isset($_SESSION["username"]) && isset($_POST["login"]) && isset($_POST["password_login"]) )
    {
        // Write login and password in session data
        $_SESSION['login']			= $_POST['login'];
        $_SESSION['password_login']	= $_POST['password_login'];
        //	$_SESSION['mail']	= $login;

		// Explode the username to get the domain
        $username_domain = explode("@", $_SESSION["login"]);

        // The first part of username (before @)
        $_SESSION['username']	= $username_domain[0];

		// If is not admin write the domain in session
        if ($username_domain[0] != "$admin")
            $_SESSION['domain']	= $username_domain[1];
    }

    // If not logged show the form login
    elseif (!isset($_SESSION["login"]) || !isset($_SESSION["password_login"]))
    {
        form_login ();
        echo ("</BODY></HTML>");
        exit;
    }

}

// If login system is unused set the values from config.inc.php
if (NOLOGIN == '1')
{
    $_SESSION['login']		= $admin;
    $_SESSION['password_login']	= $secret;
    $_SESSION['username']		= $admin;
}

// *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=* //

											
// For  PHP4 >= 4.2.0 or PHP5 set ldap protocol version
if (version_compare(phpversion(), "4.2.0", ">="))
{
    ldap_set_option($connect,LDAP_OPT_PROTOCOL_VERSION,3);
}

///////////////////////////////////////////////////////////////////////

// *?*?*?* Try the BIND ?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?* //

// Try a bind as postmaster
if ($_SESSION['username'] == 'postmaster' && $connect)
{
    $r=ldap_bind($connect, "cn=postmaster, jvd=$_SESSION[domain], $LDAP_BASE", "$_SESSION[password_login]");

}

// Try a bind as manager
elseif ($_SESSION["login"] == "$admin")
{
    $r=ldap_bind($connect, "cn=$admin, $SUFFIX", "$_SESSION[password_login]");
}

// Try bind as user
else
{
    $r=ldap_bind($connect, "mail=$_SESSION[login], jvd=$_SESSION[domain], $LDAP_BASE", "$_SESSION[password_login]");

}

// If not credential is OK, destroi session and print login form
if ($r != '1')
{
    session_register("login");
    session_register("password_login");
    session_register("username");
    session_unset();
    session_destroy();
    form_login ();
    echo ("</BODY></HTML>");
    exit;
}

elseif ($r)
{
	if (isset($_SESSION["domain"]))
	    $domain = $_SESSION["domain"];
}
// *?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?*?* //

// Print link to logout
echo ("<TABLE width='100%'><TR align='right'>");
if (NOLOGIN != '1' && isset($_SESSION["login"]))
    echo ("<TD align='left'><A href='logout.php'>Logout (".$_SESSION["login"]."</A>) </TD> ");

// Choose the language
echo "<TD>";
while (list($value,$label)=each($supported_languages))
{
	echo "<A href=\"?language=".$value."\">$label</A> ";
}
echo ("</TD></TR></TABLE><HR>");

// Plugins menu
if (USE_PLUGINS == 1)
	load_plugins ();

if (DEBUG)
{
	echo "<TABLE border='1'><TR>";
	echo "<TD>action ".$action."</TD>";
	echo "<TD>step ".$step."</TD>";
	echo "<TD>domain: ".$_SESSION["domain"]."</TD>";
	echo "<TD><B>domain selected: ".$domain."</B></TD>";
	echo "<TD>login: ".$_SESSION['login']."</TD>";
	echo "<TD>username: ".$_SESSION['username']."</TD>";
	echo "<TD>mail: ".$mail."</TD>";
	echo "</TR></TABLE>";

}

// Navigation links
echo ("<DIV class='navigation'>");
echo ("<A href='?'>$lang[all] $lang[domains]</A>");

if ($domain)
{
    echo (" &gt; <A href=\"?domain=$domain\">$domain</A> ");
}

if ($mail)
    echo (" &gt; $mail ");

echo ("</DIV>");

// Plugin includer
if ($_SESSION["pn"])
{
	echo "<TABLE class='plugin_body'><TR><TD>";
	if (file_exists("./plugins/".$_SESSION["pn"]."/main.php"))
	{
		include ("./plugins/".$_SESSION["pn"]."/main.php");
	}
	
	else
	{
		echo "Plugin problem...:OOOOOOOOOOOOOOOOOOOO";
	}

	echo "</TD></TR></TABLE>";
}

// Close the connection
ldap_close($connect);

// Read footer templates
include ('./templates/footer.html.php');

?>

