<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004 Alessandro De Zorzi and Mirko Grava
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* @package functions
* @subpackage accessories
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/

// Print domains list
// ********************************************************************

function domains_list ($initial)
{
    global $lang;
    global $connect;
    global $LDAP_BASE;
    global $r;
    global $td_width;
    global $td_width_box;

    if ($initial=='ALL')
        $initial='';

    $sth = ldap_list($connect,"$LDAP_BASE","jvd=$initial*");
	
	// Order the results
	if (version_compare(phpversion(), "4.2.0", ">="))
		ldap_sort($connect, $sth,"jvd");

    $entries = ldap_get_entries($connect, $sth);

	// Free the memory
	ldap_free_result($sth);

    $tr_header = ("<TR class='header'>
                  <TD width=\"$td_width\">$entries[count] ".$lang["domains"]."</TD>
                  <TD width=\"$td_width\">".$lang["accounts"]."</TD>
                  <TD width=\"$td_width\">".$lang["aliases"]."</TD>
                  <TD width=\"$td_width\">".$lang["quota"]."</TD>
                  <TD width=\"$td_width_box\">".$lang["delete_domain"]."
				  </TD>
                  <TD width=\"$td_width_box\">".$lang["edit_accounts"]."
				  </TD>");
				  if (JAMM_COMPATIBILITY)
				  {
$tr_header .= ("<TD width=\"$td_width_box\">".$lang["appoint_postmasters"]."
				  </TD>");
				  }
	$tr_header .= ("<TD width=\"$td_width_box\">".$lang["domain_is_active"]."
				  </TD>
                  </TR>
                  ");

    echo ("<FORM METHOD='POST' ACTION=\"$_SERVER[PHP_SELF]\" name='add'>");
    echo ("<INPUT type='hidden' name='action' value='domains_modify_group'>");
    echo ("<INPUT type='hidden' name='domain' value=\"");
	if (isset($domain))
		echo "$domain";
	echo ("\">");

    echo ("<TABLE class='data'>\n");
    echo $tr_header;
    for ($idx=0; $idx < $entries["count"]; $idx++)
    {
        $domain=$entries[$idx]["jvd"][0];
        //$quota=$entries[$idx]["quota"][0];
        $editA=$entries[$idx]["editaccounts"][0];
        $active=$entries[$idx]["accountactive"][0];
        $delete=$entries[$idx]["delete"][0];
		if (JAMM_COMPATIBILITY)
        	$editP=$entries[$idx]["editpostmasters"][0];

        echo ("<TR class='data'>");
        echo ("<TD><A href=\"?domain=$domain\">$domain</A></TD>");
        echo ("<TD align='center'>");
        echo mail_count ($domain);
        echo ("</TD>");
        echo ("<TD align='center'>");
        echo alias_count ($domain);
        echo ("</TD>");
        echo ("<TD>");
		$quota = domain_quota_used ($domain);
		if ($quota > 0)
		{
			$quotaf = quota_formatting(domain_quota_used ($domain));
			echo $quotaf["value"]." ".$quotaf["label"];
		}
		echo ("</TD>");
        true_false_box ($delete, $domain,'domains_delete','domains_modify_group',0);
        true_false_box ($editA, $domain,'domains_edit','domains_modify_group',0);
		if (JAMM_COMPATIBILITY)
	        true_false_box ($editP, $domain,'domains_postmaster','domains_modify_group',0);
        true_false_box ($active, $domain,'domains_active','domains_modify_group',0);
        echo ("</TR>\n");
    }
    echo ("<TR class='footer'><TD colspan='5'>");
    form_modify('modify_domains');
    echo ("</TD><TD colspan='3'></TD>");
	echo ("</TR>");

    echo ("</TABLE>\n");
}
?>
