<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004,2005 Alessandro De Zorzi and Mirko Grava
 *
 * This file is part of Phamm.
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* @package application
* @subpackage pdns
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/

function getMXIP ($dc)
{
    global $domain;
    global $DNS_LDAP_BASE;
    global $connect;

    $domain2 = explode (".",$domain);

    if (DNS_DN_MODE == 'full')
    {
        $filter = "(dc=$domain2[0])";
        $search = ldap_search($connect, "dc=$domain2[1],$DNS_LDAP_BASE",$filter);
    }

    else
    {
        $filter = "(dc=$dc)";
        $search = ldap_search($connect, "dc=$domain,$DNS_LDAP_BASE",$filter);
    }

    $results = ldap_get_entries($connect, $search);

    ldap_free_result($search);

    // Return the results
    return $results[0]["arecord"][0];
}
//
// ********************************************************************

function dnsZone ($domain)
{
    global $lang;
    global $connect;
    global $DNS_LDAP_BASE;
    global $td_width;
    global $td_width_box;

    $domain2 = explode (".",$domain);

    if (DNS_DN_MODE == 'full')
    {
        $filter="(&(dc=*)(!(dc=$domain2[0]))(!(dc=mail*)))";
        $search = ldap_search($connect, "dc=$domain2[1],$DNS_LDAP_BASE",$filter);
    }

    else
    {
        $filter="(&(dc=*)(!(dc=$domain))(!(dc=mail*)))";
        $search=ldap_search($connect, "dc=$domain,$DNS_LDAP_BASE", $filter);
    }

    // Order the results
    if (version_compare(phpversion(), "4.2.0", ">="))
        ldap_sort($connect, $search,"mail");

    $results = ldap_get_entries($connect, $search);

    // Free the memory
    ldap_free_result($search);

    $tr_header = ("<TR class='header'>
                  <TD width=\"$td_width_box\">dc</TD>
                  <TD width=\"$td_width_box\">aRecord</TD>
                  <TD width=\"$td_width_box\">cNAMERecord</TD></TR>");

    echo ("<FORM METHOD='POST' ACTION=\"$_SERVER[PHP_SELF]\" name='add'>");
    echo ("<INPUT type='hidden' name='action' value='mail_modify_group'>");
    echo ("<INPUT type='hidden' name='domain' value=\"$domain\">");

    echo ("<TABLE class='data'>\n");
    echo $tr_header;
    for ($idx=0; $idx < $results["count"]; $idx++)
    {
        $dc = $results[$idx]["dc"][0];
        $aRecord = $results[$idx]["arecord"][0];
        $cNAMERecord = $results[$idx]["cnamerecord"][0];

        echo ("<TR>");
        echo ("<TD><A href=\"?domain=$domain&mail=$mail&action=modify_mail\">$dc</A></TD>");
        echo ("<TD>$aRecord</TD>");
        echo ("<TD>$cNAMERecord</TD>");
        echo ("</TR>\n");
    }


    echo ("</TABLE>\n");
}

function dnsDomain ($domain)
{
    global $lang;
    global $connect;
    global $DNS_LDAP_BASE;
    global $td_width;
    global $td_width_box;

    $domain2 = explode (".",$domain);

    if (DNS_DN_MODE == 'full')
    {
        $filter = "(dc=$domain2[0])";
        $search = ldap_search($connect, "dc=$domain2[1],$DNS_LDAP_BASE",$filter);
    }

    else
    {
        $filter="(dc=$domain)";
        $search=ldap_search($connect, "dc=$domain,$DNS_LDAP_BASE",$filter);
    }

    // Order the results
    if (version_compare(phpversion(), "4.2.0", ">="))
        ldap_sort($connect, $search,"mail");

    $results = ldap_get_entries($connect, $search);

    $dc = $results[0]["dc"][0];
    $aRecord = $results[0]["arecord"];
    $cNAMERecord = $results[0]["cnamerecord"][0];
    $mXRecord = $results[0]["mxrecord"];
    $nSRecord = $results[0]["nsrecord"];
    $sOARecord = $results[0]["soarecord"];

    // Free the memory
    ldap_free_result($search);

    $tr_header = ("<TR class='header'>
                  <TD width=\"$td_width_box\">".$domain2[0].".".$domain2[1]."</TD>
                  <TD width=\"$td_width_box\"></TD></TR>");

    echo ("<FORM METHOD='POST' ACTION=\"$_SERVER[PHP_SELF]\" name='add'>");
    echo ("<INPUT type='hidden' name='action' value='dns_modify'>");
    echo ("<INPUT type='hidden' name='domain' value=\"$domain\">");

    echo ("<TABLE class='data'>\n");
    echo $tr_header;


    // Print all aRecords
    for ($idx=0; $idx < $aRecord["count"]; $idx++)
    {
        echo ("<TR><TD>aRecord</TD><TD>");
        echo ("<INPUT type=\"text\" size=\"15\" maxlength=\"15\"
              name=\"aRecord[]\" value=\"".$results[0]["arecord"][$idx]."\">");
        echo ("</TD></TR>");
    }

    // Print all MX Records + 1 blank
    for ($idx=0; $idx < ($mXRecord["count"]+1); $idx++)
    {
        $mx = explode (" ",$results[0]["mxrecord"][$idx]);
        $mxX = explode (".",$mx[1]);
        $mxIP = getMXIP ($mxX[0]);


        if ($idx == $mXRecord["count"])
            echo ("<TR><TD><B>new MX -></TD><TD>");
        else
            echo ("<TR><TD>MX</TD><TD>");
        echo ("<INPUT type=\"text\" size=\"2\" maxlength=\"2\"");
        if ($idx == $mXRecord["count"])
            echo " class=\"add\" ";
        echo ("name=\"mxP[]\" value=\"".$mx[0]."\">");
        echo ("<INPUT type=\"text\" size=\"25\" maxlength=\"50\"");
        if ($idx == $mXRecord["count"])
            echo " class=\"add\" ";
        echo ("name=\"mxA[]\" value=\"".$mx[1]."\">");
        echo ("<INPUT type=\"text\" size=\"15\" maxlength=\"15\"");
        if ($idx == $mXRecord["count"])
            echo " class=\"add\" ";
        echo ("name=\"mxIP[]\" value=\"".$mxIP."\">");
        echo ("</TD></TR>");
    }

    // Print all nSRecords + 1 blank
    for ($idx=0; $idx < ($nSRecord["count"]+1); $idx++)
    {
        if ($idx == $nSRecord["count"])
            echo ("<TR><TD><B>new DNS -></B></TD><TD>");
        else
            echo ("<TR><TD>DNS</TD><TD>");
        echo ("<INPUT type=\"text\" size=\"25\" maxlength=\"50\"");
        if ($idx == $nSRecord["count"])
            echo " class=\"add\" ";
        echo ("name=\"nSRecord[]\" value=\"".$results[0]["nsrecord"][$idx]."\">");
        echo ("</TD></TR>");
    }


    // Print all sOARecords
    for ($idx=0; $idx < $sOARecord["count"]; $idx++)
    {
        echo ("<TR><TD>SOA</TD><TD>");
        echo ("<INPUT type=\"text\" size=\"50\" maxlength=\"50\"
              value=\"".$results[0]["soarecord"][$idx]."\">");
        echo ("</TD></TR>");
    }
    echo ("</TR>\n");

    echo ("</TABLE>\n");

    form_modify('dns_modify');
}

function dnsModify ($domain,$aRecord,$nSRecord,$mxP,$mxA,$mxIP)
{
    global $lang;
    global $connect;
    global $DNS_LDAP_BASE;

    echo var_dump($info);

    for ($idx=0; $idx < count($aRecord); $idx++)
    {
        if ($aRecord[$idx] != "")
            $info["aRecord"][] = $aRecord[$idx];
    }

    for ($idx=0; $idx < count($nSRecord); $idx++)
    {
        if ($nSRecord[$idx] != "")
            $info["nSRecord"][] = $nSRecord[$idx];
    }

    for ($idx=0; $idx < count($mxA); $idx++)
    {
        if ($mxA[$idx] != "")
            $info["mXRecord"][] = $mxP[$idx]." ".$mxA[$idx];

	// Add the zone if not exist
	//	$mxDc = explode (".",$mxA);
	//	addZone ($domain,$mxDc[0],$mxIP,$mxDc[0].".".$domain);
    }

    echo var_dump($info);

    $r=ldap_modify($connect, "dc=$domain,$DNS_LDAP_BASE", $info);

    return $r;
}

// Add a zona
//

function addZone ($domain,$dc,$aRecord,$associatedDomain)
{
    global $DNS_LDAP_BASE;
    global $connect;

    $domain2 = explode (".",$domain);
	
	$info["objectclass"][]		= "top";
	$info["objectclass"][]		= "dnsdomain";
    $info["objectclass"][]		= "domainrelatedobject";

	$info["dc"] = "$dc";
	$info["arecord"] = "$aRecord";
	$info["associateddomain"] = $dc.".".$domain;

    if (DNS_DN_MODE == 'full')
    {
	    $r=ldap_add($connect, "dc=$dc,dc=$domain2[0],dc=$domain2[1],$DNS_LDAP_BASE", $info);
	}
	
    else
    {
	    echo "dc=$dc,dc=$domain,$DNS_LDAP_BASE";
    	$r = ldap_add($connect, "dc=$dc,dc=$domain,$DNS_LDAP_BASE", $info);
	}

	return $r;
}

?>
