<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004-2005 Alessandro De Zorzi and Mirko Grava
 *  
 * Phamm is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Phamm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* @package application
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/


// Require the library file with all functions
// require ('phamm_functions.inc.php');
// To develop include single file funtion
// this is not a safe way to include file :-P
$mydir = opendir("functions");
while($fn = readdir($mydir))
{
    if (substr($fn,-3) == 'php')
        require ("functions/$fn");
}
closedir($mydir);

// Require locale file
if (file_exists("./lang/$language.php"))
    require ("./lang/$language.php");
else
    require ("./lang/en_GB.php");

// User or default values
if (!$_POST['LDAP_SERVER'])
	$LDAP_SERVER='127.0.0.1';
else
	$LDAP_SERVER = $_POST['LDAP_SERVER'];

if (!$_POST['LDAP_PORT'])
	$LDAP_PORT='389';
else
	$LDAP_PORT = $_POST['LDAP_PORT'];

if (!$_POST['SUFFIX'])
	$SUFFIX='dc=example,dc=tld';
else
	$SUFFIX = $_POST['SUFFIX'];

if (!$_POST['admin'])
	$admin='manager';
else
	$admin = $_POST['admin'];

// Check the PHP version
$PHPVERSION=phpversion();

if (version_compare($PHPVERSION, "4.1.0", ">="))
{
	$phpCheck='TRUE';
}

else
{
	$phpCheck='FALSE';
}

$step = $_GET['step'];
if (!$_GET['step'])
	$step = $_POST['step'];
$conf = $_GET['conf'];


// Read header template
include ('./templates/header.html.php');

if (!$step)
{
	echo ("<H1>Test setup wizard...</H1>");
	echo ("<P>!! This is a beta version to create your config.inc.php
	use the <B>config.inc.php.template</B> to create your config.inc.php
	if you get some error
	simply<BR> <B>cp config.inc.php.template config.inc.php</B></P>
	");
	echo $a;
	echo ("<TABLE class=\"data\">");
	echo ("<TR><TD>PHP</TD><TD>$PHPVERSION</TD><TD>");
	echo ("<IMG src=\"./img/$phpCheck.png\"></TD></TR>");
	echo ("</TABLE>");

	if ($phpCheck=='TRUE')
	{
		echo ("<A href='?step=2'>Go --></A>");
	}
	else
		echo ("Go -->");
}


if ($step == '2')
{
	echo ("<FORM METHOD=\"POST\" ACTION=\"$_SERVER[PHP_SELF]\" name=\"add\">");
	echo ("<TABLE class=\"data\">");

	echo ("<INPUT type=\"hidden\" name=\"step\"
	value=\"2\">");

	echo ("<TR><TD>LDAP_SERVER</TD>
	<TD><INPUT type=\"text\" name=\"LDAP_SERVER\"
	value=\"$LDAP_SERVER\" size=\"20\"></TD></TR>");

	echo ("<TR><TD>LDAP_PORT</TD>
	<TD><INPUT type=\"text\" name=\"LDAP_PORT\"
	value=\"$LDAP_PORT\" size=\"5\"></TD></TR>");

	echo ("<TR><TD>SUFFIX</TD>
	<TD><INPUT type=\"text\" name=\"SUFFIX\"
	value=\"$SUFFIX\" size=\"40\"></TD></TR>");

	echo ("<TR><TD>admin</TD>
	<TD><INPUT type=\"text\" name=\"admin\"
	value=\"$admin\"></TD></TR>");

	echo ("</TABLE>");
	echo ("<INPUT type=\"submit\" value=\"Create\">");
	echo ("</FORM>");

	echo "Copy and paste the text in your conf.inc.php<BR>";

	echo "<TEXTAREA cols='73' rows='20'>";
	echo '<?php'."\n";
	echo "// This is the main Phamm config file\n";
	echo "/////////////////////////////////////\n\n";

	echo "// LDAP Server Setting\n";
	echo ('$LDAP_SERVER'." = \"$LDAP_SERVER\";\n");
	echo ("define (LDAP_PORT,'$LDAP_PORT');\n");
	echo ('$SUFFIX'." = \"$SUFFIX\";\n");
	echo ('$admin'." = \"$admin\";\n\n");
	
	echo "// Phamm access control\n";
	echo "define (NOLOGIN,0);\n";
	echo '$secret'." = '';\n";
	echo "define (FORCE_SSL,0);\n\n";
	
	echo "// Layout setting\n";
	echo '$version'." = \"0.0.22\";\n";
	echo '$language'." = \"en_GB\";\n";
	echo '$td_width'." = \"200\";\n";
	echo '$td_width_box'." = \"100\";\n";
	echo '$title'." = \"Phamm\";\n";
	echo "define (REFRESH_TIME,1);\n\n";

	echo "// Security options\n";
	echo '$password_min_length'." = 2;\n\n";

	echo "// Default attribute setting\n";
	echo '$editAccounts'." = \"TRUE\";\n";
	echo '$editPostmasters'." = \"TRUE\";\n";
	echo '$accountActive'." = \"TRUE\";\n\n";

	echo "// Template message\n";
	echo "define (SEND_WELCOME,0);\n";
	echo '$welcome_msg'." = './templates/welcome_message.txt';\n";
	echo '$welcome_subject'." = 'Welcome!';\n";
	echo '$welcome_sender'." = '<support@example.tld>';\n\n";

	echo "// Vacation\n";
	echo "define (USE_VACATION, 1);\n\n";

	echo "// Amavis\n";
	echo "define (USE_AMAVIS, 0);\n";

	echo "// Advanced settings\n";
	echo "define (DEBUG,0);\n";
	echo "define (ERROR_LEVEL,1);\n";
	echo "define (ADVANCED_VIEW,0);\n";
	echo "define (JAMM_COMPATIBILITY,0);\n\n";

	
	echo '?>';

	echo ("</TEXTAREA>");

}

// Read footer templates
include ('./templates/footer.html.php');

?>
